package webwisdom.pim;

import java.awt.*;
import java.awt.event.*;
import java.rmi.*;
import java.applet.*;
import webwisdom.tango.pim.*;
import java.io.*;
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.table.*;
import java.sql.*;
import java.util.*;
import java.net.*;

class StatisticsPane extends JPanel implements ActionListener
{
  PIMAdmin pa;
  JLabel   l1,l2,l3,l4,l5,l6;
  JButton  btUpdate;
  
  StatisticsPane(PIMAdmin pa)
    {
      this.pa=pa;
      l1=new JLabel();
      l2=new JLabel();
      l3=new JLabel();
      l4=new JLabel();
      l5=new JLabel();
      l6=new JLabel();
      btUpdate=new JButton("UPDATE STATISTICS");
      btUpdate.addActionListener(this);
      setLayout(new BorderLayout());
      JPanel p0;
      JPanel p1;
      add("Center",p0=new JPanel());
      add("South",btUpdate);
      add("North",p1=new JPanel());
      p1.setLayout(new GridLayout(6,1));
      p1.add(l1);
      p1.add(l2);
      p1.add(l3);
      p1.add(l4);
      p1.add(l5);
      p1.add(l6);
      
      actionPerformed(null);
    }
  public void actionPerformed(ActionEvent ev)
    {
      try
	{
	  Statement stmt=pa.conn.createStatement();
	  ResultSet rset=stmt.executeQuery("SELECT count(*) FROM users");
	  if(rset.next())
	    l1.setText("Total number of Users:"+rset.getInt(1));
	  rset=stmt.executeQuery("SELECT count(*) FROM communities");
	  if(rset.next())
	    l2.setText("Total number of Communities:"+rset.getInt(1));
	  rset=stmt.executeQuery("SELECT count(*) FROM registry_user");
	  if(rset.next())
	    l3.setText("Entries in User Registry:"+rset.getInt(1));
	  rset=stmt.executeQuery("SELECT count(*) FROM registry_community");
	  if(rset.next())
	    l4.setText("Entries in Community Registry:"+rset.getInt(1));
	  rset=stmt.executeQuery("SELECT count(*) FROM registry_global");
	  if(rset.next())
	    l5.setText("Entries in Global Registry:"+rset.getInt(1));
	  rset=stmt.executeQuery("SELECT count(*) FROM user_data");
	  if(rset.next())
	    l6.setText("Entries in User Personal Data:"+rset.getInt(1));
	  stmt.close();
	  repaint();
	}
      catch(SQLException e)
	{
	  System.err.println("ex in stat upd:"+e);
	}
    }
}

/******************************************************************************/

class DBUserTableModel extends AbstractTableModel 
{
  class UserEntry
  {
    int uid;
    String ulogin;
    String fname;
    String minit;
    String lname;
    UserEntry(int _uid, String _ulogin, String _fname, String _minit, String _lname)
      {uid=_uid; ulogin=_ulogin; fname=_fname; minit=_minit; lname=_lname;}
  }

  Vector data;
  String ocol;
  String login_pattern=null;
  String fname_pattern=null;
  String lname_pattern=null;
  String headers[]={"ulogin","fname","lname"};
  Connection conn;
  Integer minusone;
  
  DBUserTableModel(Connection conn)
    {
      this.conn=conn;
      data=new Vector();
      setSortKey(0);
      minusone=new Integer(-1);
    }

  void setSortKey(int i)
    {
      if(!headers[i].equals(ocol))
	 {
	   ocol=headers[i];
	   update();
	 }
    }

  void setPatterns(String lpattern,String fnpattern,String lnpattern)
    {
      boolean b=false;
      if((login_pattern!=null && !login_pattern.equals(lpattern)) ||
	 (login_pattern==null && lpattern!=null))
	b=true;
      if((fname_pattern!=null && !fname_pattern.equals(fnpattern)) ||
	 (fname_pattern==null && fnpattern!=null))
	b=true;
      if((lname_pattern!=null && !lname_pattern.equals(lnpattern)) ||
	 (lname_pattern==null && lnpattern!=null))
	b=true;
      login_pattern=lpattern;
      fname_pattern=fnpattern;
      lname_pattern=lnpattern;
      System.out.println("Patterns:'"+lpattern+"','"+fnpattern+"','"+lnpattern+"'");
      if(b)update();
    }
  
  void update()
    {
      try
	{
	  Statement stmt;
	  ResultSet rset;
	  String stmtstr="";
	  if(login_pattern!=null)
	    stmtstr+="ulogin like '"+login_pattern+"' ";
	  if(fname_pattern!=null)
	    {
	      if(stmtstr.length()!=0)
		stmtstr+="AND fname like '"+fname_pattern+"' ";
	      else
		stmtstr+="fname like '"+fname_pattern+"' ";
	    }
	  if(lname_pattern!=null)
	    {
	      if(stmtstr.length()!=0)
		stmtstr+="AND lname like '"+lname_pattern+"' ";
	      else
		stmtstr+="lname like '"+lname_pattern+"' ";
	    }
	  if(stmtstr.length()!=0)
	    stmtstr="WHERE "+stmtstr;
	  stmt=conn.createStatement();
	  rset=stmt.executeQuery("SELECT u_id,ulogin,fname,minit,lname FROM users "+
				 stmtstr+" ORDER BY "+ocol);
	  data.removeAllElements();
	  while(rset.next())
	    {
	      UserEntry ue=new UserEntry(rset.getInt(1),rset.getString(2),
					 rset.getString(3),rset.getString(4),
					 rset.getString(5));
	      data.addElement(ue);
	    }
	}
      catch(SQLException e)
	{
	  System.err.println("ex in ulist upd:"+e);
	}
      fireTableDataChanged();
    }

  public int getRowCount()
    {
      return data.size();
    }

  public int getColumnCount()
    {
      return 3;
    }

  public Object getValueAt(int row,int column)
    {
      if(row<0 || row>=data.size())
	return minusone;
      UserEntry ue=(UserEntry)data.elementAt(row);
      switch(column)
	{
	case 0: return ue.ulogin;
	case 1: return ue.fname;
	case 2: return ue.lname;
	default: return new Integer(ue.uid);
	}
    }

  public String getColumnName(int column)
    {
      return headers[column];
    }
}

class UserList extends JPanel implements ActionListener,KeyListener
{
  PIMAdmin pa;
  JTextField tf1;
  JTextField tf2;
  JTextField tf3;
  JTable     jt;
  DBUserTableModel dbtm;
  JScrollPane jsp;
  JTableHeader th;
  UserList(PIMAdmin pa)
    {
      this.pa=pa;
      setLayout(null);
      dbtm=new DBUserTableModel(pa.conn);
      dbtm.update();
      tf1=new JTextField("*");
      tf2=new JTextField("*");
      tf3=new JTextField("*");
      tf1.addActionListener(this);
      tf2.addActionListener(this);
      tf3.addActionListener(this);
      jt=new JTable(dbtm);
      jsp=new JScrollPane(jt,ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
      TableColumn tc;
      tc=jt.getColumn("ulogin");
      tc.setResizable(false);
      tc.setMinWidth(60);
      tc.setMaxWidth(60);
      tc=jt.getColumn("fname");
      tc.setResizable(false);
      tc.setMinWidth(70);
      tc.setMaxWidth(70);
      tc=jt.getColumn("lname");
      tc.setResizable(false);
      tc.sizeWidthToFit();
      add(tf1);
      add(tf2);
      add(tf3);
      add(jsp);
      th=jt.getTableHeader();
      th.setReorderingAllowed(false);
      jt.setColumnSelectionAllowed(false);
      MouseAdapter listMouseListener = new MouseAdapter()
	{
	  public void mouseClicked(MouseEvent e)
	    {
	      TableColumnModel columnModel = jt.getColumnModel();
	      int viewColumn = columnModel.getColumnIndexAtX(e.getX());
	      int column=jt.convertColumnIndexToModel(viewColumn);
	      System.out.println("Sorting by:"+column);
	      jt.clearSelection();
	      dbtm.setSortKey(column);
	    }
	};
      th.addMouseListener(listMouseListener);
      jt.addKeyListener(this);
    }
  class MyDialog extends UniversalDialog
  {
    UserList ul;
    MyDialog(UserList ul0)
      {
	super(ul0,"Are you sure you want to delete selected users?");
	this.ul=ul0;
      }
    public void action(boolean b)
      {
	if(b)
	  {
	    int rows[]=ul.jt.getSelectedRows();
	    for(int i=0;i<rows.length;i++)
	      {
		try
		  {
		    int uid=((Integer)ul.dbtm.getValueAt(rows[i],-1)).intValue();
		    Statement stmt=ul.pa.conn.createStatement();
		    stmt.executeUpdate("DELETE FROM user_data WHERE u_id="+uid);
		    stmt.executeUpdate("DELETE FROM registry_user WHERE u_id="+uid);
		    stmt.executeUpdate("DELETE FROM community_access WHERE u_id="+uid);
		    stmt.executeUpdate("DELETE FROM users WHERE u_id="+uid);
		    stmt.close();
		  }
		catch(SQLException ex)
		  {
		    ex.printStackTrace();
		  }
	      }
	    System.out.println("DELETING");
	    ul.dbtm.update();
	    ul.jt.clearSelection();
	  }
      }
  }
  
  public void keyPressed(KeyEvent e)
    {
      if(e.getKeyCode()==e.VK_DELETE && e.getModifiers()==0)
	{
	  UniversalDialog ud=new MyDialog(this);
	  ud.show();
	}
    }
  
  public void keyReleased(KeyEvent e)
    {
    }
  public void keyTyped(KeyEvent e)
    {
    }

   public String convertPattern(String s)
    {
      char ca[]=s.toCharArray();
      boolean b0=false;
      for(int i=0;i<ca.length;i++)
	{
	  if(ca[i]>='a' && ca[i]<='z') b0=true;
	  if(ca[i]>='A' && ca[i]<='Z') b0=true;
	  if(ca[i]=='%') ca[i]='_';
	  if(ca[i]=='*') ca[i]='%';
	  if(ca[i]=='?') ca[i]='_';
	}
      if(b0)
	return new String(ca);
      else
	return null;
    }
  
  public void actionPerformed(ActionEvent e)
    {
      jt.clearSelection();
      dbtm.setPatterns(convertPattern(tf1.getText()),
		       convertPattern(tf2.getText()),
		       convertPattern(tf3.getText()));
    }

  public void doLayout()
    {
      super.doLayout();
      Insets i=getInsets();
      Dimension d0=getSize();
      d0.width-=(i.left+i.right);
      d0.height-=(i.top+i.bottom);
      int h0=0;
      System.out.println(d0);
      h0=Math.max(tf1.getPreferredSize().height,h0);
      h0=Math.max(tf2.getPreferredSize().height,h0);
      h0=Math.max(tf3.getPreferredSize().height,h0);
      int cm=jt.getColumnModel().getColumnMargin();
      tf1.setBounds(i.left,i.top,60,h0);
      tf2.setBounds(i.left+60+cm,i.top,70,h0);
      tf3.setBounds(i.left+130+2*cm,i.top,jt.getColumn("lname").getWidth(),h0);
      jsp.setBounds(i.left,i.top+h0,d0.width,d0.height-h0);
    }
}

class DBCommAccessTableModel extends AbstractTableModel 
{
  
  class CommunityAccess
  {
    int cid;
    String cname;
    String type;
    String old;
    CommunityAccess(int _cid, String _cname, String _type)
      {
	cid=_cid;
	cname=_cname;
	type=_type;
	old=_type;
      }
  }

  
  
  Vector data;
  String ocol;
  int uid=0;
  boolean showall=true;
  String headers[]={"Community","Access Type"};
  Connection conn;
  Integer minusone;
  JPanel jp=new JPanel();


  void commit(int uid)
    {
      for(int i=0;i<data.size();i++)
	{
	  try
	    {
	      CommunityAccess ca=(CommunityAccess)data.elementAt(i);
	      if(ca.type!=null && ca.old==null)
		{
		  Statement stmt=conn.createStatement();
		  int res=stmt.executeUpdate("INSERT INTO community_access (u_id,cid,acctype) VALUES ( "+
					     uid+","+ca.cid+",'"+ca.type+"')");
		  stmt.close();
		}
	      else if(ca.type==null && ca.old!=null)
		{
		  Statement stmt=conn.createStatement();
		  int res=stmt.executeUpdate("DELETE FROM community_access WHERE u_id="+uid+
					     " AND cid="+ca.cid);
		  stmt.close();
		}
	      else if(ca.type!=null && !ca.type.equals(ca.old))
		{
		  Statement stmt=conn.createStatement();
		  int res=stmt.executeUpdate("UPDATE community_access SET acctype='"+ca.type+"' WHERE u_id="+uid+
					     " AND cid="+ca.cid);
		  stmt.close();
		}
	    }
	  catch(Exception e)
	    {
	      e.printStackTrace();
	    }
	}
    }
  
  public void setValueAt(Object o,int row,int column)
    {
      if(row<0 || row>=data.size())
	return;
      if(column==1)
	{
	  CommunityAccess ca=(CommunityAccess)data.elementAt(row);
	  ca.type=(String)o;
	  System.out.println(row+","+column+":"+ca.type);
	}
    }
  
  public Class getColumnClass(int c)
    {
      if(c==1)
	return jp.getClass();
      return (new String()).getClass();
    }

  public boolean isCellEditable(int rowIndex, int columnIndex) 
    {
      if(columnIndex==1 && showall==true)
	return true;
      return false;
    }
  
  void setUser(int uid)
    {
      this.uid=uid;
    }

  void setMode(boolean showall)
    {
      this.showall=showall;
    }
  
  DBCommAccessTableModel(Connection conn)
    {
      this.conn=conn;
      data=new Vector();
      minusone=new Integer(-1);
    }

  void update()
    {
      try
	{
	  Statement stmt;
	  ResultSet rset;
	  stmt=conn.createStatement();
	  if(showall==false)
	    rset=stmt.executeQuery("SELECT a.cid,a.name,b.acctype FROM communities a,community_access b "+
				   "WHERE a.cid=b.cid AND b.u_id="+uid+" ORDER BY a.name");
	  else
	    rset=stmt.executeQuery("SELECT a.cid,a.name,b.acctype FROM communities a,"+
				   "(SELECT * FROM community_access WHERE u_id="+uid+
				   ") b WHERE a.cid=b.cid(+) ORDER BY a.name");
	  data.removeAllElements();
	  while(rset.next())
	    {
	      CommunityAccess ca=new CommunityAccess(rset.getInt(1),rset.getString(2),
					 rset.getString(3));
	      data.addElement(ca);
	    }
	}
      catch(SQLException e)
	{
	  System.err.println("ex in ulist upd:"+e);
	}
      fireTableDataChanged();
    }

  public int getRowCount()
    {
      return data.size();
    }

  public int getColumnCount()
    {
      return 2;
    }

  public Object getValueAt(int row,int column)
    {
      if(row<0 || row>=data.size())
	return minusone;
      CommunityAccess ca=(CommunityAccess)data.elementAt(row);
      switch(column)
	{
	case 0: return ca.cname;
	case 1: return ca.type;
	default: return new Integer(ca.cid);
	}
    }

  public String getColumnName(int column)
    {
      return headers[column];
    }
}


class MyCellEditor extends DefaultCellEditor implements ActionListener
{
  JComponent cc;
  JRadioButton jbre0;
  JRadioButton jbre1;
  JRadioButton jbre2;
  JPanel       jcpe1;
  ButtonGroup bg2;
  int row;
  int column;
  JTable jt;
  public MyCellEditor()
    {
      super(new JTextField());
      cc=new JComponent(){};
      jcpe1=new JPanel()     
	{
	  public void doLayout()
	    {
	      super.doLayout();
	      Dimension d=getSize();
	      for(int i=0;i<3;i++)
		{
		  Component c=getComponent(i);
		  Rectangle r=c.getBounds();
		  c.setBounds(r.x,(d.height-r.height)/2,r.width,r.height);
		}
	    }
	};
      jcpe1.setLayout(new FlowLayout(FlowLayout.CENTER));
      jbre0=new JRadioButton();
      jbre0.setActionCommand("0");
      jbre1=new JRadioButton();
      jbre0.setActionCommand("1");
      jbre2=new JRadioButton();
      jbre0.setActionCommand("2");
      bg2=new ButtonGroup();
      jcpe1.add(jbre0);
      jcpe1.add(jbre1);
      jcpe1.add(jbre2);
      bg2.add(jbre0);
      bg2.add(jbre1);
      bg2.add(jbre2);
      jbre0.addActionListener(this); 
      jbre1.addActionListener(this); 
      jbre2.addActionListener(this); 
    }
  public void actionPerformed(ActionEvent e)
    {
      fireEditingStopped();
    }

  public Object getCellEditorValue()
    {
      if(jbre1.isSelected())
	return "a";
      if(jbre2.isSelected())
	return "b";
      return null;
    }
  public Component   getTableCellEditorComponent(JTable table,
						 java.lang.Object value,
						 boolean isSelected, int row, int column)
    {
      this.row=row;
      this.column=column;
      this.jt=table;
      jbre0.setSelected(value==null);
      jbre1.setSelected(value!=null && value.equals("a"));
      jbre2.setSelected(value!=null && value.equals("b"));
      jcpe1.setEnabled(true);
      jcpe1.setBackground(super.getTableCellEditorComponent
			  (table,value,isSelected,row,column).getBackground());
      return jcpe1;
    }
 
}

class UserRightPanel extends JPanel implements ActionListener
{
  Connection conn;
  UserPane up;
  
  JPanel jp0;
  JPanel jp1;
  JScrollPane jsp0;
  JPanel jp2;
  JComponent jc0;
  
  JTextField jtf1;
  JTextField jtf2;
  JTextField jtf3;
  JTextField jtf4;
  JTextField jtf5;
  JTextField jtf6;
  JTextField jtf7;
  
  String login="";
  String fname="";
  String minit="";
  String lname="";
  String email="";
  String descr="";
  String pass="";

  JButton jb1;
  JButton jb2;

  public final static int BROWSE=0;
  public final static int NEW=1;
  public final static int EDIT=2;
  int mode=BROWSE;
  int current_uid;
  Image photo;
  byte[] photoarray;
  byte[] oldphotoarray;
  Image oldphoto;

  DBCommAccessTableModel dbca;
  JTextField imgurl;
  JLabel     urllab;
  
  JRadioButton jbr0;
  JRadioButton jbr1;
  JRadioButton jbr2;
  JPanel       jcp0;
  JTable       jt0;
  DefaultCellEditor tce;
  PreparedStatement psdel;
  PreparedStatement psins;
  
  void setSelection(int k)
    {
      if(current_uid==k)
	return;
      if(k<0)
	{
	  login="";
	  descr="";
	  fname="";
	  minit="";
	  lname="";
	  pass="";
	  email="";
	  oldphoto=null;
	  oldphotoarray=null;
	  if(mode==BROWSE)
	    {
	      setEnabledFields(false);
	      jc0.repaint();
	    }
	  return;
	}
      try
	{
	  current_uid=k;
	  Statement stmt=conn.createStatement();
	  ResultSet rset;
	  rset=stmt.executeQuery("SELECT ulogin,descr,fname,minit,"+
					   "lname,upass FROM users WHERE u_id="+k);
	  if(rset.next())
	    {
	      login=rset.getString(1);
	      descr=rset.getString(2);
	      fname=rset.getString(3);
	      minit=rset.getString(4);
	      lname=rset.getString(5);
	      pass=rset.getString(6);
	    }
	  rset=stmt.executeQuery("SELECT value FROM user_data WHERE u_id="+
				 k+" AND key='e-mail'");
	  if(rset.next())
	    {
	      ByteArrayInputStream bis=new ByteArrayInputStream(rset.getBytes(1));
	      ObjectInputStream ois=new ObjectInputStream(bis);
	      Object o=ois.readObject();
	      if(o instanceof String)
		email=(String)o;
	      else
		email="";
	    }

	  rset=stmt.executeQuery("SELECT value FROM user_data WHERE u_id="+
				 k+" AND key='photo'");
	  if(rset.next())
	    {
	      oldphotoarray=rset.getBytes(1);
	      oldphoto=Toolkit.getDefaultToolkit().createImage(oldphotoarray);
	    }
	  else
	    {
	      photoarray=null;
	      photo=null;
	    }
	  stmt.close();
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
      if(mode==BROWSE)
	{
	  setEnabledFields(false);
	  jc0.repaint();
	  jt0.clearSelection();
	  tce.cancelCellEditing();
	  
	}
    }

  
  
  UserRightPanel(UserPane up,Connection conn) 
    {
      try
	{
	  this.conn=conn;
	  this.up=up;
	  setLayout(null);
	  add(jp0=new JPanel());
	  add(jp1=new JPanel());

	  jbr0=new JRadioButton();
	  jbr1=new JRadioButton();
	  jbr2=new JRadioButton();
	  jcp0=new JPanel()
	    {
	      public void doLayout()
		{
		  super.doLayout();
		  Dimension d=getSize();
		  for(int i=0;i<3;i++)
		    {
		      Component c=getComponent(i);
		      Rectangle r=c.getBounds();
		      c.setBounds(r.x,(d.height-r.height)/2,r.width,r.height);
		    }
		}
	    };
	    jcp0.setLayout(new FlowLayout(FlowLayout.CENTER));
	    ButtonGroup bg1=new ButtonGroup();
	    jcp0.add(jbr0);
	    jcp0.add(jbr1);
	    jcp0.add(jbr2);
	    bg1.add(jbr0);
	    bg1.add(jbr1);
	    bg1.add(jbr2);
      
 
      
	    TableCellRenderer tcr=new DefaultTableCellRenderer()
	      {
		public java.awt.Component getTableCellRendererComponent(JTable table,
									java.lang.Object value,
									boolean isSelected,
									boolean hasFocus,
									int row,
									int column)
		  {
		    jbr0.setSelected(value==null);
		    jbr1.setSelected(value!=null && value.equals("a"));
		    jbr2.setSelected(value!=null && value.equals("b"));
		    jcp0.setEnabled(true);
		    jcp0.setBackground(super.getTableCellRendererComponent
				       (table,value,isSelected,hasFocus,row,column).getBackground());
		    return jcp0;
		  }
	      };
	      JTextField jtf=new JTextField();
	      tce=new MyCellEditor();
      
	      tce.setClickCountToStart(0);
	      jt0=new JTable(dbca=new DBCommAccessTableModel(conn));
	      jt0.getColumn("Access Type").setCellRenderer(tcr);
	      jt0.getColumn("Access Type").setCellEditor(tce);
	      add(jsp0=new JScrollPane(jt0));
      
	      jp0.setLayout(new GridLayout(1,2));
	      jp0.add(jb1=new JButton("New"));
	      jp0.add(jb2=new JButton("Edit"));
  
	      jp1.setLayout(new GridLayout(8,2,5,5));
	      jp1.add(new JLabel("Login : ",SwingConstants.RIGHT));
	      jp1.add(jtf1=new JTextField(15));
	      jp1.add(new JLabel("Password : ",SwingConstants.RIGHT));
	      jp1.add(jtf2=new JPasswordField(15));
	      jp1.add(new JLabel("First  Name : ",SwingConstants.RIGHT));
	      jp1.add(jtf3=new JTextField(15));
	      jp1.add(new JLabel("Middle  Initial : ",SwingConstants.RIGHT));
	      jp1.add(jtf4=new JTextField(5));
	      jp1.add(new JLabel("Last  Name : ",SwingConstants.RIGHT));
	      jp1.add(jtf5=new JTextField(25));
	      jp1.add(new JLabel("e-mail : ",SwingConstants.RIGHT));
	      jp1.add(jtf6=new JTextField(25));
	      jp1.add(new JLabel("description : ",SwingConstants.RIGHT));
	      jp1.add(jtf7=new JTextField(25));
	      jp1.add(urllab=new JLabel("photo URL : ",SwingConstants.RIGHT));
	      jp1.add(imgurl=new JTextField(40));


	      jtf1.setEnabled(false);
	      jtf2.setEnabled(false);
	      jtf3.setEnabled(false);
	      jtf4.setEnabled(false);
	      jtf5.setEnabled(false);
	      jtf6.setEnabled(false);

	      jb1.addActionListener(this);
	      jb2.addActionListener(this);
	      jc0=new JComponent()
		{
		  public void paint(Graphics g)
		    {
		      Dimension d=getSize();
		      int h=d.height-60;
		      int w=d.width-20;
		      if(photo!=null)
			{
			  g.drawImage(photo,10,20,w,h,this);
			}
		      else
			{
			  g.setColor(Color.black);
			  g.drawLine(10,20,10+w,20+h);
			  g.drawLine(10+w,20,10,20+h);
			  g.drawRect(10,20,w,h);
			}
		    }
		}
	      ;
	      add(jc0);
	      imgurl.setActionCommand("image");
	      imgurl.addActionListener(this);
	      urllab.setVisible(false);
	      imgurl.setVisible(false);

	      psdel=conn.prepareStatement("DELETE FROM user_data WHERE u_id=? AND key=?");
	      psins=conn.prepareStatement("INSERT INTO user_data (u_id,key,value) VALUES (?,?,?)");
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
    }
  
  public void doLayout()
    {
      Insets i=getInsets();
      Dimension d=getSize();
      jp1.setBounds(i.left,i.top,d.width-i.left-i.right-130,
		    jp1.getPreferredSize().height);
      jp0.setBounds(i.left,d.height-i.bottom-jp0.getPreferredSize().height,
		    d.width-i.left-i.right,jp0.getPreferredSize().height);
      jc0.setBounds(d.width-i.left-i.right-130,i.top,120,jp1.getPreferredSize().height);
      jsp0.setBounds(i.left,i.top+jp1.getSize().height+10,d.width-i.left-i.right,
		    d.height-(i.top+jp1.getSize().height+10)-(jp0.getSize().height+10));
    }

  void setEnabledFields(boolean b)
    {
      jtf1.setEnabled(b);
      jtf2.setEnabled(b);
      jtf3.setEnabled(b);
      jtf4.setEnabled(b);
      jtf5.setEnabled(b);
      jtf6.setEnabled(b);
      jtf7.setEnabled(b);
      if(b==false)
	{
	  jtf1.setText(login);
	  jtf2.setText(pass);
	  jtf3.setText(fname);
	  jtf4.setText(minit);
	  jtf5.setText(lname);
	  jtf6.setText(email);
	  jtf7.setText(descr);
	  photoarray=oldphotoarray;
	  photo=oldphoto;
	  jb1.setText("New");
	  jb2.setText("Edit");
	  mode=BROWSE;
	  imgurl.setVisible(false);
	  urllab.setVisible(false);

	  jt0.clearSelection();
	  tce.cancelCellEditing();
	  jbr0.setVisible(false);
	  dbca.setUser(current_uid);
	  dbca.setMode(false);
	  dbca.update();
	}
      else
	{
	  oldphotoarray=photoarray;
	  oldphoto=photo;
	  jb1.setText("OK");
	  jb2.setText("Cancel");
	  imgurl.setVisible(true);
	  urllab.setVisible(true);
	  imgurl.setText("");

	  jt0.clearSelection();
	  tce.cancelCellEditing();
	  jbr0.setVisible(true);
	  dbca.setMode(true);
	  dbca.update();
	}
    }

  public void actionPerformed(ActionEvent e)
    {
      if(e.getActionCommand().equals("image"))
	{
	  try
	    {
	      URL u=new URL(imgurl.getText());
	      InputStream is=u.openStream();
	      byte b[]=new byte[4096];
	      ByteArrayOutputStream bos=new ByteArrayOutputStream();
	      int k=is.read(b);
	      int i=k;
	      while(k>=0)
		{
		  bos.write(b,0,k);
		  k=is.read(b);
		  i+=k;
		}
	      b=bos.toByteArray();
	      Image img=Toolkit.getDefaultToolkit().createImage(b);
	      photoarray=b;
	      photo=img;
	      jc0.repaint();
	    }
	  catch(Exception ee)
	    {
	      ee.printStackTrace();
	    }
	}
      if(e.getActionCommand().equals("New"))
	{
	  mode=NEW;
	  dbca.setUser(-1);
	  setEnabledFields(true);
	  jtf1.setText("");
	  jtf2.setText("");
	  jtf3.setText("");
	  jtf4.setText("");
	  jtf5.setText("");
	  jtf6.setText("");
	  jtf7.setText("");
	  photo=null;
	  photoarray=null;
	  jc0.repaint();
	}
      if(e.getActionCommand().equals("Edit"))
	{
	  mode=EDIT;
	  dbca.setUser(current_uid);
	  setEnabledFields(true);
	}
      if(e.getActionCommand().equals("Cancel"))
	{
	  setEnabledFields(false);
	}
      if(e.getActionCommand().equals("OK") && mode==NEW)
	{
	  try
	    {
	      Statement stmt=conn.createStatement();
	      int res;
	      int nid=0;
	      ResultSet rset=stmt.executeQuery("SELECT user_seq.nextval FROM DUAL");
	      if(rset.next())
		nid=rset.getInt(1);
	      res=stmt.executeUpdate("INSERT INTO users (u_id,ulogin,upass,fname,lname,minit,descr) "+
				     "VALUES ("+
				     nid+",'"+
				     jtf1.getText()+"','"+
				     jtf2.getText()+"','"+
				     jtf3.getText()+"','"+
				     jtf5.getText()+"','"+
				     jtf4.getText()+"','"+
				     jtf7.getText()+"')");
	      PreparedStatement pstmt;
	      pstmt=conn.prepareStatement("INSERT INTO user_data (u_id,key,value) VALUES (?,?,?)");
	      updateValue(nid,"name.first",tba(jtf3.getText()));
	      updateValue(nid,"name.middle",tba(jtf4.getText()));
	      updateValue(nid,"name.last",tba(jtf5.getText()));
	      updateValue(nid,"e-mail",tba(jtf6.getText()));
	      if(photo!=null)
		updateValue(nid,"photo",photoarray);
	      dbca.commit(nid);
	    }
	  catch(SQLException ee)
	    {
	      ee.printStackTrace();
	    }
	  setEnabledFields(false);
	  up.update();
	}
      if(e.getActionCommand().equals("OK") && mode==EDIT)
	{
	  try
	    {
	      Statement stmt=conn.createStatement();
	      int res;
	      res=stmt.executeUpdate("UPDATE users SET ulogin='"+jtf1.getText()+
				     "',upass='"+jtf2.getText()+
				     "',fname='"+jtf3.getText()+
				     "',minit='"+jtf4.getText()+
				     "',lname='"+jtf5.getText()+
				     "',descr='"+jtf7.getText()+"' WHERE u_id="+current_uid);
	      
	      updateValue(current_uid,"name.first",tba(jtf3.getText()));
	      updateValue(current_uid,"name.middle",tba(jtf4.getText()));
	      updateValue(current_uid,"name.last",tba(jtf5.getText()));
	      updateValue(current_uid,"e-mail",tba(jtf6.getText()));
	      if(photoarray!=null)
		updateValue(current_uid,"photo",photoarray);
	      dbca.commit(current_uid);
	    }
	  catch(SQLException ee)
	    {
	      ee.printStackTrace();
	    }
	  setEnabledFields(false);
	  up.update();
	}
    }
  byte[] tba(Object o)
    {
      try
	{
	  ByteArrayOutputStream bos=new ByteArrayOutputStream();
	  ObjectOutputStream oos=new ObjectOutputStream(bos);
	  oos.writeObject(o);
	  return bos.toByteArray();
	}
      catch(Exception e)
	{
	}
      return new byte[0];
    }
  void updateValue(int uid,String key,byte[] value)
    {
      try
	{
	  psdel.setInt(1,uid);
	  psdel.setString(2,key);
	  psdel.executeUpdate();
	  psins.setInt(1,uid);
	  psins.setString(2,key);
	  psins.setBytes(3,value);
	  psins.executeUpdate();
	}
      catch(Exception e)
	{
	  System.out.println("Exception");
	  e.printStackTrace();
	}
    }
  
}


class UserPane extends JPanel implements ListSelectionListener
{
  PIMAdmin pa;
  UserList ul;
  UserRightPanel urp;
  
  UserPane(PIMAdmin pa) throws Exception
    {
      this.pa=pa;
      setLayout(null);
      ul=new UserList(pa);
      urp=new UserRightPanel(this,pa.conn);
      add(ul);
      add(urp);
      ul.jt.getSelectionModel().addListSelectionListener(this);
      ul.jt.getSelectionModel().setSelectionMode(com.sun.java.swing.ListSelectionModel.SINGLE_SELECTION);
    }

  public void valueChanged(ListSelectionEvent e)
    {
      if(!e.getValueIsAdjusting())
	urp.setSelection(((Integer)ul.dbtm.getValueAt(e.getFirstIndex(),3)).intValue());
    }

  public void update()
    {
      ul.dbtm.update();
    }

  public void doLayout()
    {
      super.doLayout();
      Insets i=getInsets();
      ul.setBounds(i.left,i.top,250,getSize().height-i.top-i.bottom);
      urp.setBounds(i.left+250,i.top,getSize().width-i.left-i.right-250,
		    getSize().height-i.top-i.bottom);
    }
  
}



/*****************************************************************************************/

class DBCommunityTableModel extends AbstractTableModel 
{
  class CommunityEntry
  {
    int cid;
    String name;
    String descr;
    CommunityEntry(int _cid, String _name,String _descr)
      {cid=_cid; name=_name; descr=_descr;}
  }

  Vector data;
  String ocol;
  String headers[]={"name","description"};
  Connection conn;
  Integer minusone;
  String name="";
  String descr="";
  
  DBCommunityTableModel(Connection conn)
    {
      this.conn=conn;
      data=new Vector();
      minusone=new Integer(-1);
    }

  void update()
    {
      try
	{
	  Statement stmt;
	  ResultSet rset;
	  stmt=conn.createStatement();
	  rset=stmt.executeQuery("SELECT cid,name,description FROM communities "+
				 " ORDER BY name");
	  data.removeAllElements();
	  while(rset.next())
	    {
	      CommunityEntry ue=new CommunityEntry(rset.getInt(1),rset.getString(2),
					 rset.getString(3));
	      data.addElement(ue);
	    }
	}
      catch(SQLException e)
	{
	  System.err.println("ex in ulist upd:"+e);
	}
      fireTableDataChanged();
    }

  public int getRowCount()
    {
      return data.size()+1;
    }

  public int getColumnCount()
    {
      return 2;
    }

  public Object getValueAt(int row,int column)
    {
      if(row==data.size())
	{
	  if(column==0)
	    return name;
	  else if(column==1)
	    return descr;
	  else
	    return minusone;
	}
      if(row<0 || row>data.size())
	return minusone;
      CommunityEntry ce=(CommunityEntry)data.elementAt(row);
      switch(column)
	{
	case 0: return ce.name;
	case 1: return ce.descr;
	default: return new Integer(ce.cid);
	}
    }

  public String getColumnName(int column)
    {
      return headers[column];
    }
  public boolean isCellEditable(int row, int column) 
    {
      if(row==data.size())
	return true;
      if(column==1)
	return true;
      return false;
    }
  
  public void setValueAt(Object o,int row,int column)
    {
      try
	{
	  if(row==data.size())
	    {
	      if(column==0)
		name=o.toString();
	      if(column==1)
		descr=o.toString();
	      if(!name.equals("") && !descr.equals(""))
		{
		  Statement stmt=conn.createStatement();
		  stmt.executeUpdate("INSERT INTO communities (cid,name,description) VALUES "+
				     "(community_seq.nextval,'"+name+"','"+descr+"')");
		  name="";
		  descr="";
		  stmt.close();
		  update();
		}
	    }
	  else if(column==1)
	    {
	      CommunityEntry ce=(CommunityEntry)data.elementAt(row);
	      ce.descr=o.toString();;
	      Statement stmt=conn.createStatement();
	      stmt.executeUpdate("UPDATE communities SET description='"+o+"' WHERE cid="+ce.cid);
	      stmt.close();
	    }
	}
      catch(SQLException ee)
	{
	  ee.printStackTrace();
	}
    }
  void delete(int i)
    {
      try
	{
	  if(i>=data.size() || i<0)
	    return;
	  CommunityEntry ce=(CommunityEntry)data.elementAt(i);
	  Statement stmt=conn.createStatement();
	  stmt.executeUpdate("DELETE FROM community_access WHERE cid="+ce.cid);
	  stmt.executeUpdate("DELETE FROM registry_community WHERE cid="+ce.cid);
	  stmt.executeUpdate("DELETE FROM communities WHERE cid="+ce.cid);
	  stmt.close();
	}
      catch(SQLException e)
	{
	  e.printStackTrace();
	}
    }
}

class CommunityPane extends JPanel
{
  PIMAdmin pa;
  JTable jt;
  JScrollPane jsp;
  DBCommunityTableModel dbcm;
  CommunityPane(PIMAdmin pa)
    {
      this.pa=pa;
      dbcm=new DBCommunityTableModel(pa.conn);
      add("Center",jsp=new JScrollPane(jt=new JTable(dbcm)));
      KeyAdapter ka=new KeyAdapter()
	{
	  public void  keyPressed(KeyEvent ke)
	    {
	      if(ke.getKeyCode()==ke.VK_DELETE && ke.getModifiers()==0)
		{
		  int rows[]=jt.getSelectedRows();
		  for(int i=0;i<rows.length;i++)
		    dbcm.delete(rows[i]);
		  dbcm.update();
		}
	    }
	};
      jt.addKeyListener(ka);
      update();
    }
  void update()
    {
      dbcm.update();
    }
}

/************************************************************************************/

class RegistryPane extends JPanel
{
  PIMAdmin pa;
  RegistryPane(PIMAdmin pa)
    {
      this.pa=pa;
    }
}

public class PIMAdmin extends JApplet
{
  int uid=-1;
  UserPane up;
  CommunityPane cp;
  RegistryPane rp;
  StatisticsPane sp;
  Connection conn;
  
  
  public void init()
    {
      try
	{
	  DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
	  conn=DriverManager.getConnection("jdbc:oracle:thin:@sunrise.npac.syr.edu:1521:frog","piotr","piotr");
	  JTabbedPane jtp=new JTabbedPane();
	  JButton jb=new JButton("Tango Administration");
	  getContentPane().add("Center",jtp);
	  getContentPane().add("North",jb);
      
	  jtp.addTab("Statistics",sp=new StatisticsPane(this));
	  jtp.addTab("Users",up=new UserPane(this));
	  jtp.addTab("Communities",cp=new CommunityPane(this));
	  jtp.addTab("Registry",rp=new RegistryPane(this));
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	  System.exit(1);
	}
    }
}
